# подключение библиотек
import numpy as np
import cv2 as cv
from PIL import ImageTk, Image
from time import time

# подключение проводной камеры (порт может быть 0 или 1 в зависимости от устройства)
cam_port = 0 # 0 - 1
cam = cv.VideoCapture(cam_port) 
cam.set(cv.CAP_PROP_SETTINGS, 1);
# загрузка может длиться 1 - 2 минуты
print("Камера загружена")

def Pixels(path): # преобразование фото открытого с пути path в массив пикселей
    image = Image.open(path).convert('RGB')
    image = image.resize((48, 120))
    image = np.asarray(image)
    return image.copy()

def S(path): # функция счёта площади детали после удаления фона
    image = Image.open(path).convert('RGB')
    image = np.asarray(image)
    Count = 0
    for j in range(120):
        for i in range(48):
            R, G, B = image[j][i]
            if G > 40 or G > 40 or B > 40:
                Count += 1
    return Count

Exemple = {} # множество хранения средних площадей деталей
#            {"Название детали":<средний размер детали>}

def What(S): # функция сравнения деталей с откалиброванными значениями
    global Exemple
    if Exemple != {}:
        Min = 48 * 120
        Detal = ""
        for Name in Exemple.keys():
            R = abs(S - Exemple[Name])
            if R < Min:
                R = Min
                Detal = Name
        return Detal
    else:
        return "Вы не сохранили ни одной детали"

def Scan():
    t = time()
    result, image = cam.read()

    cv.imwrite("img.png", image) 
    img = Image.open("img.png").convert('RGBA')
    img = img.crop((224,0,416,480)) # 640 480 # 48 120
    img = img.resize((48, 120)) # 640 480
    p_img = img.load()
    #print(p_img)
    for i in range(48):
        for j in range(120):
            R, G, B = fon[j][i]
            Rp, Gp, Bp, Ap = p_img[i, j]
            #if Gp > Rp and Gp > Bp:
            #    p_img[i, j] = 0, 0, 0, 255
            p_img[i, j] = abs(R - Rp), abs(G - Gp), abs(B - Bp), 255
    img.save("result.png")
    c = S("result.png")
    return c

Inst = """
Инструкция (команды):
1 - Сохранение пустого конвеера (калибровка)
0 или просто Enter (пусто)- Вычислить какая деталь 
2 - сохранить новую деталь
Для сохранения новой детали программа попросит 
cделать 3 калибровочных фото детали
Лучше фотографировать деталь в разных положениях

Для выхода из программы - любая другая строка
"""
print(Inst)
while True:
    Actions = input()
    if Actions == "1":
        t = time()
        result, image = cam.read() 
        image = image[0:480, 224:416] # 640 480 # 48 120
        cv.imwrite("fon.png", image) 
        fon = Pixels("fon.png")
        print("Фон сохранён")
        #print("time:",round(time() - t, 3))

    elif Actions == "" or Actions == "0":
        c = Scan()
        print("Площадь равна:", c, "  Определена деталь:", What(c))
        #print("S = ", c)
        #print(What(c))
        #print("time:",round(time() - t, 3))
    elif Actions == "2":
        input("1) Положите деталь на конвейер для калибровки и нажмите Enter")
        C1 = Scan()
        input("2) Положите деталь на конвейер для калибровки и нажмите Enter")
        C2 = Scan()
        input("3) Положите деталь на конвейер для калибровки и нажмите Enter")
        C3 = Scan()
        C = (C1 + C2 + C3) / 3
        print("1", C1, " 2", C2, " 3", C3," Среднее значение", C)
        name = input("Напишите название детали: ")
        Exemple[name] = C
        print("Деталь успешно сохранена")
    else:
        break